summaryrefslogtreecommitdiffstats
path: root/src/util
diff options
context:
space:
mode:
authorStefan Hajnoczi2010-02-05 23:15:18 +0100
committerMarty Connor2010-03-04 17:38:29 +0100
commit6a6f26f74da733862832d5ea79e2776d84d0a78d (patch)
tree93da82d748796c8b821af7bec42847358ef16289 /src/util
parent[build] Disable ccache for embedded.o (diff)
downloadipxe-6a6f26f74da733862832d5ea79e2776d84d0a78d.tar.gz
ipxe-6a6f26f74da733862832d5ea79e2776d84d0a78d.tar.xz
ipxe-6a6f26f74da733862832d5ea79e2776d84d0a78d.zip
[fnrec] Add function recorder for debugging
The function recorder is a crash and hang debugging tool. It logs each function call into a memory buffer while gPXE runs. After the machine is reset, and if the contents of memory have not been overwritten, gPXE will detect the memory buffer and print out its contents. This allows developers to see a trace of the last functions called before a crash or hang. The util/fnrec.sh script can be used to convert the function addresses back into symbol names. To build with fnrec: make FNREC=1 Signed-off-by: Stefan Hajnoczi <stefanha@gmail.com> Signed-off-by: Marty Connor <mdc@etherboot.org>
Diffstat (limited to 'src/util')
-rwxr-xr-xsrc/util/fnrec.sh32
1 files changed, 32 insertions, 0 deletions
diff --git a/src/util/fnrec.sh b/src/util/fnrec.sh
new file mode 100755
index 00000000..00784ac5
--- /dev/null
+++ b/src/util/fnrec.sh
@@ -0,0 +1,32 @@
+#!/bin/bash
+#
+# Copyright (C) 2010 Stefan Hajnoczi <stefanha@gmail.com>.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation; either version 2 of the
+# License, or any later version.
+#
+# This program is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+# General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+
+if [ $# != 2 ]
+then
+ cat >&2 <<EOF
+usage: $0 <elf-binary> <addresses-file>
+Look up symbol names in <elf-binary> for function addresses from
+<addresses-file>.
+
+Example:
+$0 bin/gpxe.hd.tmp fnrec.dat
+EOF
+ exit 1
+fi
+
+tr ' ' '\n' <"$2" | addr2line -fe "$1" | awk '(NR % 2) { print }'